--- Makefile.orig	2022-11-08 02:24:56.000000000 +1100
+++ Makefile	2024-12-29 20:22:02.927325224 +1100
@@ -23,6 +23,8 @@
 
 # Compiler flags for various configurations:
 
+SO_VERSION=1
+
 CFLAGS := -std=c99 -pedantic -Wall -Wextra -Wno-unused-parameter
 
 ifeq "$(CC)" "clang"
@@ -40,7 +42,6 @@
   LDFLAGS += -fsanitize=address
 else ifeq "$(build)" "release"
   CFLAGS += -O2
-  LDFLAGS += -Wl,-s
 endif
 
 ifeq "$(HAVE_READLINE)" "yes"
@@ -88,7 +89,8 @@
 
 $(OUT)/libmujs.$(SO_EXT): one.c $(HDRS)
 	@ mkdir -p $(@D)
-	$(CC) $(CFLAGS) $(CPPFLAGS) -fPIC -shared $(LDFLAGS) -o $@ $< -lm
+	$(CC) $(CFLAGS) $(CPPFLAGS) -fPIC -shared -Wl,-soname,libmujs.$(SO_EXT).$(SO_VERSION) -o $@ $< -lm
+	ln -sf libmujs.$(SO_EXT).$(SO_VERSION) $@
 
 libmujs ?= libmujs.a
 
@@ -127,7 +129,9 @@
 	install -m 644 $(OUT)/libmujs.a $(DESTDIR)$(libdir)
 
 install-shared: install-common $(OUT)/libmujs.$(SO_EXT)
-	install -m 755 $(OUT)/libmujs.$(SO_EXT) $(DESTDIR)$(libdir)
+	install -m 755 $(OUT)/libmujs.$(SO_EXT).$(SO_VERSION) $(DESTDIR)$(libdir)
+	cp -af build/release/libmujs.$(SO_EXT) $(DESTDIR)$(libdir)
+	chmod 0755 $(DESTDIR)$(libdir)
 
 install: install-static
 
@@ -137,6 +141,7 @@
 	rm -f $(DESTDIR)$(libdir)/pkgconfig/mujs.pc
 	rm -f $(DESTDIR)$(libdir)/libmujs.a
 	rm -f $(DESTDIR)$(libdir)/libmujs.$(SO_EXT)
+	rm -f $(DESTDIR)$(libdir)/libmujs.$(SO_EXT).$(SO_VERSION)
 
 tarball:
 	git archive --format=zip --prefix=mujs-$(VERSION)/ HEAD > mujs-$(VERSION).zip
